/* TCHK 0.60 - Howard Kapustein's Turbo C library      1-15-88 */
/* Copyright (C) 1988, Howard Kapustein.  All rights reserved. */

/* ibm.h  -  header file for IBM.C - IBM specific functions */

#ifndef IBM_HEX_ID
#define PC            0xFF
#define XT            0xFE
#define Portable_PC   0xFE
#define PCjr          0xFD
#define AT            0xFC
#define Compaq        0x2D
#define Compaq_Plus   0x9A
#define IBM_HEX_ID    1
#endif

#ifndef MEM_STRATEGY
#define MEM_STRAT_FIRST 0         /* use first mem block large enough */
#define MEM_STRAT_BEST  1         /* use smallest mem block large enough */
#define MEM_STRAT_LAST  2         /* use high part of last usable mem block */
#define MEM_STRAT_BADDOS -1       /* using DOS earlier than 3.xx */
#define MEM_STRATEGY    1
#endif

#ifndef DISK_ID_BYTE
#define DISK_DSDD_8     0xFF      /* Double-sided, 5 1/4" floppy, 8 sectors */
#define DISK_SSDD_8     0xFE      /* Single-sided, 5 1/4" floppy, 8 sectors */
#define DISK_SS8_8      0xFE      /* Single-sided, 8" floppy, 8 sectors */
#define DISK_DSDD_9     0xFD      /* Double-sided, 5 1/4" floppy, 9 sectors */
#define DISK_SSDD_9     0xFC      /* Single-sided floppy, 9 sectors */
#define DISK_DSQD_15    0xF9      /* Double-sided, 5 1/4" floppy, 15 sectors */
#define DISK_DS3_15     0xF9      /* Double-sided, 3 1/2" floppy, 9 sectors */
#define DISK_HARD       0xF8      /* Hard disk */
#define DISK_DS3_18     0xF0      /* Double-sided, 3 1/2" floppy, 18 sectors */
#define DISK_UNDEFINED  0xF0      /* undefined media type */
/* Note: if the disk is Single-sided, 8" 26 sectors,
         it could have the id FE or FD                  */
#define DISK_ERROR      0x0       /* error, try checking _doserrno */
#define DISK_ID_BYTE    1
#endif

#ifndef EMS_CODES
#define EMS_ERROR_SOFTWARE  0x80       /* error in EMM software */
#define EMS_ERROR_HARDWARE  0x81       /* malfunction in EM hardware */
#define EMS_ERROR_UNDEFINED 0x84       /* function requested not defined */
#define EMS_CODES   1
#endif

/* function prototypes */
byte ROM_id(void);                           /* get id */
char *ROM_date(void);
boolean isEMSavail(void);              /* is EMS available */
boolean isBREAKon(void);               /* check Ctrl-BREAK flag */
boolean setBREAK(boolean break_status);     /* set Ctrl-BREAK flag */
boolean isVERIFYon(void);              /* check Verify flag */
boolean setVERIFY(boolean verify_status); /* set Verify flag */
void reboot(boolean warmboot);         /* reboot, warmboot vs. coldboot */
int memory_strategy(boolean read, int *strategy); /* get/set mem alloc strategy */
boolean isNetwork(void);               /* is a Network installed */
byte disktype(byte drive);             /* type of disk (0=default, A=1, etc.) */
boolean isExtended(void);              /* is Extended memory available */
int Extendedtotal(void);               /* total amount of Extended memory (in K) */
boolean EMMversion(byte *version);     /* version or (on failure) error code */